/**
 * Atari 800 Demo
 * Remake Java by German Gonzalez
 * 
 * the idea it was to made a "conversion" of the atari basic code
 */

import java.applet.Applet;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Polygon;
import java.util.Random;

public class Atari800Demo extends Applet {

    //original global variables
	public static int ppx, ppy;
	public static int nl, xl, yl, x, y;
	public static String a="";
	int px, py;
	
	//delays
	public static int pl=40, dr=40, d1=40, d2=40, letra=320;
	
	public static int of_x=8, of_y=1;

	//colors
	static Color color_1 = Color.black;
	static Color color_2 = Color.green;
	static Color color_10 = Color.red;
	static Color color_14 = Color.orange;
	static Color color_7 = Color.blue;
	static Color color_9 = Color.cyan;

	
    public void paint(Graphics g)
    {
    	goto1000(g);
		goto100(g);
    }


    public void plot(Graphics g, int x, int y){
    	g.drawLine(x, y, x , y);
    	ppx = x;
    	ppy = y;
    	try {
			Thread.sleep(pl);
		} catch (InterruptedException e) {
			e.printStackTrace();
		} 
    }
    
    public void drawto(Graphics g, int x, int y){
    	g.drawLine(ppx, ppy, x , y);
    	ppx = x;
    	ppy = y;
    	
    	try {
			Thread.sleep(dr);
		} catch (InterruptedException e) {
			e.printStackTrace();
		} 
    }

    public void gosub18000(Graphics g){
        
    	for(int i=1; i<=nl; i++) {
    		plot(g, x,y+i-1);
    		drawto(g, x+xl,y+i-1);
    	}
    }
    
    public void gosub18100(Graphics g){
        
    	for(int i=0; i<=nl; i++) {
    		plot(g, x+i,y);
    		drawto(g, x+i,y+yl);
    	}
    }

    public void gosub14000(Graphics g){
        
        plot(g,x,y);
        drawto(g,x,y+3);
        plot(g,x+3,y);
        drawto(g,x+3,y+3);
        plot(g,x+1,y-1);
        drawto(g,x+2,y-1);
		plot(g,x+1,y+1);
		drawto(g,x+2,y+1); 
    }
    
    public void gosub14100(Graphics g){
        
        plot(g,x,y);
        drawto(g,x,y+2);
        plot(g,x+4,y);
        drawto(g,x+4,y+2);
        plot(g,x+1,y-1);
        drawto(g,x+3,y-1);
		plot(g,x+1,y+3);
		drawto(g,x+3,y+3); 
    }

    
    
    public void goto1000(Graphics g) {
    	
    	/*implementar drawto y plot, con un objeto static global que recuerda la ultima posicion (pal drawto)
    	 */
    	 
    	 ppx = 0;
    	 ppy = 0;
    	
		 //color 1;
    	 g.setColor(color_1);
    	 
    	 plot(g,100,91);
    	 drawto(g,224,91);
		 //border
		 drawto(g,247,174);
		 drawto(g,243,178);
		 drawto(g,204,178);
		 drawto(g,200,181);
		 drawto(g,123,181);
		 drawto(g,119,178);
		 drawto(g,81,178);
		 drawto(g,77,174);
		 drawto(g,100,91);
		 plot(g,78,175);
		 drawto(g,246,175);
		 plot(g,78,169);
		 drawto(g,246,169);
		 plot(g,247,174);
		 drawto(g,230,126);
		 drawto(g,218,114);
		 drawto(g,106,114);
		 drawto(g,94,126); 
		 drawto(g,77,174);
		 plot(g,210,91); 
		 drawto(g,214,113);
		 drawto(g,214,128); 
		 drawto(g,176,128);
		 drawto(g,176,129);
		 drawto(g,148,129);
		 drawto(g,148,128);
		 drawto(g,110,128);
		 drawto(g,110,113);
		 drawto(g,114,91);
		 plot(g,111,107);
		 drawto(g,212,107);

		 x=113; xl=6; y=117;nl=6; gosub18000(g);
		 //color 2;
    	 g.setColor(color_2);
		 
		 plot(g,116,118);
		 drawto(g,116,121);
		 plot(g,116,119);
		 drawto(g,114,121);
		 plot(g,116,119);
		 drawto(g,118,121);
		 //color 1
    	 g.setColor(color_1);

    	 plot(g,122,116);
		 drawto(g,164,116);
		 drawto(g,164,124);
		 drawto(g,122,124);
		 drawto(g,122,116);
		 x=124;y=119;gosub14000(g);

		 plot(g,129,118);
		 drawto(g,131,118);
		 plot(g,130,118);
		 drawto(g,130,122);
		 x=133;y=119;gosub14000(g);
		 plot(g,138,118);
		 drawto(g,138,122);
		 plot(g,139,118);
		 drawto(g,140,118);
		 plot(g,141,119);
		 drawto(g,141,122);
		 plot(g,141,120);
		 drawto(g,138,120);
		 plot(g,144,118);
		 drawto(g,144,122);
		 plot(g,147,118);
		 drawto(g,148,118);
		 plot(g,146,119);
		 plot(g,149,119);
		 plot(g,146,121);
		 plot(g,149,121);
		 plot(g,147,120);
		 drawto(g,148,120);
		 plot(g,147,122);
		 drawto(g,148,122);

		 x=151;gosub14100(g);
		 x=157;gosub14100(g);

		 //keyboard boundary
/*		 plot(g,208,134);
		 drawto(g,208,142);
		 drawto(g,207,142);
		 drawto(g,207,154);
		 drawto(g,185,154);
		 drawto(g,185,160);
		 drawto(g,113,160);
		 drawto(g,113,154);
		 drawto(g,99,154);
		 drawto(g,99,142);
		 drawto(g,98,142);
		 drawto(g,98,134);
		 plot(g,100,133);  
		 drawto(g,207,133); 
*/
		 //fill
		 //plot(g,99,133);
		 // fill???
		 //position 100,154;poke 765,1;xio 18,#6,0,0,"s;"

		 Polygon p = new Polygon();
		 plot(g,208,134);
		 p.addPoint(208,142);
		 p.addPoint(207,142);
		 p.addPoint(207,154);
		 p.addPoint(185,154);
		 p.addPoint(185,160);
		 p.addPoint(113,160);
		 p.addPoint(113,154);
		 p.addPoint(99,154);
		 p.addPoint(99,142);
		 p.addPoint(98,142);
		 p.addPoint(98,134);
		 p.addPoint(100,133);  
		 p.addPoint(207,133); 
		 g.fillPolygon(p);
		 
		 plot(g,113,153);
		 //position 113,160)
		 //;xio 18,#6,0,0,"s;"
		 
		 x=102;
		 for(int k=0; k<=14; k++){
		 	plot(g,x,132);
		 	drawto(g,x+4,132);
		 	x=x+7;
		 }
    	
		 x=117;
		 for(int k=0; k<=30; k++) {
		 	plot(g,x,91);
		 	drawto(g,x,106);
		 	x=x+3;
		 }
		 plot(g,225,134);
		 drawto(g,225,160);
		 drawto(g,215,160);
		 drawto(g,215,134);
		 drawto(g,225,134);
		 
		 
		 x=215;
		 for(int k=1; k<=6; k++) {
		 	plot(g,x,135);
		 	drawto(g,x,154);
		 	x=x+2;
		 }
		 //color 1;
    	 g.setColor(color_1);
		 plot(g,217,159); drawto(g,223,159);
		 plot(g,218,156); drawto(g,222,156);
		 
		 y=139;
		 for(int k=1; k<=4; k++) {
		 	plot(g,216,y); 	drawto(g,224,y);
		 	plot(g,217,y-1); drawto(g,223,y-1);
		 	plot(g,216,y+1); plot(g,224,y+1);
		 	y=y+5;
		 }
		 plot(g,216,135);
		 plot(g,224,135);
		 
		 
         g.setColor(Color.red);
         
		 //TV ***********
		 plot(g,90,2); drawto(g,244,2); drawto(g,244,86); drawto(g,90,86); drawto(g,90,2);
		 plot(g,91,3); drawto(g,91,85);	 plot(g,243,3);	 drawto(g,243,85);
		 x=90;xl=154;y=2;nl=2;gosub18000(g);
		 x=90;xl=154;y=82;nl=5;gosub18000(g);
		 x=90;xl=154;y=5;nl=1;gosub18000(g);
		 x=97;xl=108;y=11;nl=5;gosub18000(g);
		 x=97;xl=108;y=73;nl=6;gosub18000(g);
		 
		 x=97;y=12;yl=62;nl=5;gosub18100(g);
		 x=200;y=12;yl=62;nl=5;gosub18100(g);
		 


		 plot(g,211,8); drawto(g,237,8); drawto(g,237,78); drawto(g,211,78); drawto(g,211,8);
		 x=212;y=8;yl=69;nl=5;gosub18100(g);
		 plot(g,212,58); drawto(g,236,58);
		 x=220;y=10;yl=44;nl=6;gosub18100(g);
		 x=229;xl=4;y=12;nl=2;gosub18000(g);
		 //color 2;
    	 g.setColor(color_2);
		 
		 x=148;xl=8;y=76;nl=2;gosub18000(g);
		 y=13;
		 for(int k=1; k<=12; k++) {
		 	x=221;xl=4;nl=2;gosub18000(g);
		 	y=y+3;
		 }
		 y=69;
		 for(int k=1; k<=2; k++) {
		 	x=213;xl=2;nl=2;gosub18000(g);
		 	y=y+4;
		 }
		 plot(g,100,14); drawto(g,202,14);	 drawto(g,202,74);	 drawto(g,100,74);	 drawto(g,100,14);


    }
    
    public void gosub19000(Graphics g) {
    	// TODO: se puede imprimir letra por letra lentamente para simular demo real
    	g.setColor(Color.orange);
    	g.drawString(a, (px+1)*of_x, (py+8)*of_y);
    	try {
			Thread.sleep(letra);
		} catch (InterruptedException e) {
			e.printStackTrace();
		} 

    }

    public void gosub22100(Graphics g) {
    	try {
			Thread.sleep(d1);
		} catch (InterruptedException e) {
			e.printStackTrace();
		} 
    }
    public void gosub22000(Graphics g) {
    	try {
			Thread.sleep(d1);
		} catch (InterruptedException e) {
			e.printStackTrace();
		} 
    }
    public void gosub21000(Graphics g) {
    	try {
			Thread.sleep(d2);
		} catch (InterruptedException e) {
			e.printStackTrace();
		} 
    }
    public void gosub31000(Graphics g) {
    	try {
			Thread.sleep(d2);
		} catch (InterruptedException e) {
			e.printStackTrace();
		} 
    }
    public void gosub20000(Graphics g) {
        y=16;
        for(int i=0; i<=56; i++) {
        	plot(g,103,y+i);drawto(g,199,y+i);
        }
    }
    public void gosub23100(Graphics g) {
        y=16;
        for(int i=0; i<=47; i++) {
        	plot(g,x,16);drawto(g,x,72);
        	x=x+2;
        }
    }
    public void gosub23000(Graphics g) {
        y=16;
        for(int i=0; i<=48; i++) {
        	plot(g,x,16);drawto(g,x,72);
        	x=x+2;
        }
    }
    
    public void gosub595(Graphics g) {
        for(int k=1; k<=6; k++) {
        	x=x+3;
        	drawto(g,x,gosub591(g));
        }
    }
    
    public int gosub591(Graphics g) {
    	Random rnd = new Random( );
    	int r = 0;
    	
    	while (r<29 || r>58) {
    		r = Math.round(rnd.nextInt(100))+1;  //R=INT(RND(1)*100)
    	}
    	return r;
    }
    
    public void gosub30000(Graphics g) {
        //color 1;
    	g.setColor(color_1);
    	
    	plot(g,x+1,y);drawto(g,x+2,y);plot(g,x,y+1);drawto(g,x+3,y+1);
    	plot(g,x-1,y+2);drawto(g,x+4,y+2);plot(g, x-1,y+3);drawto(g,x+4,y+3);
    	plot(g,x,y+4);drawto(g,x+3,y+4);
    	plot(g,x+1,y+5);drawto(g,x+2,y+5);
    	plot(g, x+4,y-10);drawto(g,x+4,y+2);
    }
    

    
    public void goto100(Graphics g) {
    	
    	//100 rem 
		//105 color 2
    	g.setColor(color_2);

		px=16;py=20;a="atari";gosub19000(g);
		px=15;py=34;a="personal";gosub19000(g);
		px=15;py=42;a="computer";gosub19000(g);
		px=15;py=50;a="systems";gosub19000(g);
		gosub22100(g);
		//color 2;
		g.setColor(color_2);

		px=17;py=62;a="for";gosub19000(g);
		gosub21000(g);gosub21000(g);
		//color 2;
		g.setColor(color_2);

		gosub20000(g);
		px=14;py=40;a="education";gosub19000(g);
		//color 1;
		g.setColor(color_1);

		gosub20000(g);
		x=104;
		//color 2;
		g.setColor(color_2);

		gosub23100(g);
		px=14;py=40;a="2 + 2 = ?";gosub19000(g);
		gosub22000(g);
		//color 2;
		g.setColor(color_2);

		gosub20000(g);
		px=15;py=30;a="personal";gosub19000(g);px=15;py=40;a="finance";gosub19000(g);
		x=103;
		//color 1;
		g.setColor(color_1);

		gosub20000(g);
		//color 2;
		g.setColor(color_2);

		gosub23000(g);
		px=14;py=25;a="atari";gosub19000(g);px=20;py=25;a="800xl";gosub19000(g);
		px=13;py=35;a="for";gosub19000(g);
		px=17;py=35;a="$119";gosub19000(g);
		px=22;py=35;a="at";gosub19000(g);
		px=15;py=45;a="belks";gosub19000(g);
		px=16;py=55;a="ga.sqr.";gosub19000(g);
		gosub31000(g);gosub22000(g);
		//sound
		//color 2;
		g.setColor(color_2);

		gosub20000(g);
		//color 1
		g.setColor(color_1);

		px=15;py=30;a="personal";gosub19000(g);
		px=15;py=40;a="interest";gosub19000(g);
		//color 2;
		g.setColor(color_2);

		gosub21000(g);gosub20000(g);
		//color 1;
		g.setColor(color_1);

		y=30;
		for(int k=1; k<=5; k++) {
			plot(g,110,y);
			drawto(g,192,y);y=y+5;
		}
		
		x=127;y=45;gosub30000(g);
		x=142;y=40;gosub30000(g);x=157;y=35;gosub30000(g);x=172;y=30;gosub30000(g);
		//sound 0,220,10,8;
		gosub21000(g);
		//sound 0,200,10,8;sound 1,180,10,8;
		gosub21000(g);
		//sound 1,160,10,8
		//sound 2,140,10,8;gosub21000(g);
		//sound 2,120,10,8;sound 3,100,10,8;
		gosub21000(g);
		//sound 3,80,10,8;
		gosub21000(g);
		
		//delay for(int k=0; k<=100; k++) next k
		//for(int k=0 to 3;sound k,0,0,0;next k
		gosub22000(g);
		//color graphics
		//color 2;
		g.setColor(color_2);

		gosub20000(g);
		//color 1;
		g.setColor(color_1);

		px=13;py=30;a="professional";gosub19000(g);px=13;py=40;a="applications";gosub19000(g);
		gosub22000(g);
		//450 poke 87,8
		gosub21000(g);
		//color 1;
		g.setColor(color_1);
		
		gosub20000(g);
		//poke 87,9
		//color 10
		g.setColor(color_10);

/*		TODO: BUGON
 * 		520 X=26:Y=63:XL=22:NL=9:GOSUB 18000
		530 COLOR 14:PLOT 27,20:DRAWTO 27,60:COLOR 10:PLOT 28,60:DRAWTO 47,60
		540 Y=23:FOR K=0 TO 8:X=28:XL=0:NL=1:GOSUB 18000:Y=Y+4:NEXT K
		550 COLOR 7:PLOT 29,30
*/
		x=26;y=63;xl=22;nl=9;gosub18000(g);
		//color 14;
		g.setColor(color_14); plot(g,27,20); drawto(g,27,60);
		//color 10;
		g.setColor(color_10);
		plot(g,28,60);drawto(g,47,60);
		
		y=23;
		for(int k=0; k<=8; k++) {
			x=28; xl=0; nl=1; gosub18000(g); y=y+4;
		}
		//color 7;
		g.setColor(color_7);

		plot(g,29,30);
		
		x=29;gosub595(g);
		g.setColor(color_9); x=29; plot(g,29,50); gosub595(g);
		//poke 87,8;
		//goto 600
		//599 poke 87,8
		gosub22000(g);gosub22000(g);

		//star raiders
		//color 2;
		g.setColor(color_2);

		gosub20000(g);
		//color 1;
		g.setColor(color_1);

		px=14;py=30;a="entertain-";gosub19000(g);px=17;py=40;a="ment";gosub19000(g);
		gosub21000(g);
		//color 1;
		g.setColor(color_1);

		gosub20000(g);
		//poke 87,9
		//color 10
		g.setColor(color_10);

		x=26;y=63;xl=22;nl=9;gosub18000(g);
		//poke 87,8;//color 2;
		g.setColor(color_2);

		plot(g,139,37);drawto(g,149,37);plot(g,155,37);drawto(g,165,37);
		plot(g,152,28);drawto(g,152,34);plot(g,152,40);drawto(g,152,46);
		plot(g,173,51);drawto(g,195,51);drawto(g,195,61);drawto(g,173,61);drawto(g,173,51);
		plot(g,179,54);drawto(g,188,54);drawto(g,188,58);drawto(g,179,58);drawto(g,179,54);
		plot(g,184,51);drawto(g,184,54);plot(g,184,58);drawto(g,184,61);
		plot(g,174,56);drawto(g,179,56);plot(g,189,56);drawto(g,195,56);
		plot(g,166,28);plot(g,110,30);plot(g,150,16);plot(g,180,23);plot(g,164,50);plot(g,115,63);plot(g,130,50);
		plot(g,118,47);plot(g,114,40);plot(g,130,21);plot(g,134,41);plot(g,176,42);plot(g,172,33);
		//959 goto 965
		//960 gosub 19100
		//965 
		plot(g,130,28);drawto(g,130,30);plot(g,133,28);drawto(g,133,30);plot(g,130,29);drawto(g,133,29);
		plot(g,160,20);drawto(g,160,22);plot(g,163,20);drawto(g,163,22);plot(g,160,21);drawto(g,163,21);
		plot(g,182,55);drawto(g,182,57);plot(g,185,55);drawto(g,185,57);plot(g,182,56);drawto(g,185,56);
		//delayfor(int k=0; k<=100; k++);next k);
		//color 2);
		g.setColor(color_2);

		gosub20000(g);

    }
}


